package b4a.example;

import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	public static final boolean fullScreen = false;
	public static final boolean includeTitle = true;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "b4a.example", "b4a.example.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
            
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                BA.LogInfo("Killing previous instance (main).");
				p.finish();
			}
		}
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
		BA.handler.postDelayed(new WaitForLayout(), 5);

	}
	private static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
            
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "b4a.example", "b4a.example.main");
        anywheresoftware.b4a.keywords.Common.ToastMessageShow("This application was developed with Basic4android trial version and should not be distributed.", true);
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (BA.isShellModeRuntimeCheck(processBA)) {
			if (isFirst)
				processBA.raiseEvent2(null, true, "SHELL", false);
			processBA.raiseEvent2(null, true, "CREATE", true, "b4a.example.main", processBA, activityBA, _activity, anywheresoftware.b4a.keywords.Common.Density, mostCurrent);
			_activity.reinitializeForShell(activityBA, "activity");
		}
        initializeProcessGlobals();		
        initializeGlobals();
        
        BA.LogInfo("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        BA.LogInfo("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
//        try {
//            if (processBA.subExists("activity_actionbarhomeclick")) {
//                Class.forName("android.app.ActionBar").getMethod("setHomeButtonEnabled", boolean.class).invoke(
//                    getClass().getMethod("getActionBar").invoke(this), true);
//                BA.Log("adding event");
//            }
//        } catch (Exception e) {
//            e.printStackTrace();
//        }
		return true;
	}   
// @Override
// public boolean onOptionsItemSelected(android.view.MenuItem item) {
//    if (item.getItemId() == 16908332) {
//        processBA.raiseEvent(null, "activity_actionbarhomeclick");
//        return true;
//    }
//    else
//        return super.onOptionsItemSelected(item); 
//}
    public void onWindowFocusChanged(boolean hasFocus) {
       super.onWindowFocusChanged(hasFocus);
       if (processBA.subExists("activity_windowfocuschanged"))
           processBA.raiseEvent2(null, true, "activity_windowfocuschanged", false, hasFocus);
    }
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK &&
					android.os.Build.VERSION.SDK_INT >= 18) {
				HandleKeyDelayed hk = new HandleKeyDelayed();
				hk.kc = keyCode;
				BA.handler.post(hk);
				return true;
			}
			else {
				boolean res = new HandleKeyDelayed().runDirectly(keyCode);
				if (res)
					return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
	private class HandleKeyDelayed implements Runnable {
		int kc;
		public void run() {
			runDirectly(kc);
		}
		public boolean runDirectly(int keyCode) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true) {
                return true;
            }
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
            return false;
		}
		
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
        super.onNewIntent(intent);
		this.setIntent(intent);
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        BA.LogInfo("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            BA.LogInfo("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}

public anywheresoftware.b4a.keywords.Common __c = null;
public anywheresoftware.b4a.objects.Serial _serial1 = null;
public anywheresoftware.b4a.randomaccessfile.AsyncStreams _astreams = null;
public static boolean _connected = false;
public anywheresoftware.b4a.objects.EditTextWrapper _textlog = null;
public anywheresoftware.b4a.objects.EditTextWrapper _textsend = null;
public static int _xx = 0;
public static int _yy = 0;
public static int _valorviejo = 0;

public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
return vis;}
public static String  _activity_create(boolean _firsttime) throws Exception{
 //BA.debugLineNum = 36;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
 //BA.debugLineNum = 37;BA.debugLine="If FirstTime Then";
if (_firsttime) { 
 //BA.debugLineNum = 38;BA.debugLine="Serial1.Initialize(\"Serial1\")";
mostCurrent._serial1.Initialize("Serial1");
 };
 //BA.debugLineNum = 40;BA.debugLine="Activity.LoadLayout(\"pantalla\")";
mostCurrent._activity.LoadLayout("pantalla",mostCurrent.activityBA);
 //BA.debugLineNum = 41;BA.debugLine="Activity.AddMenuItem(\"Ayuda\", \"mnuAyuda\")";
mostCurrent._activity.AddMenuItem("Ayuda","mnuAyuda");
 //BA.debugLineNum = 42;BA.debugLine="Activity.AddMenuItem(\"Acerca\", \"mnuAcerca\")";
mostCurrent._activity.AddMenuItem("Acerca","mnuAcerca");
 //BA.debugLineNum = 43;BA.debugLine="End Sub";
return "";
}
public static String  _activity_pause(boolean _userclosed) throws Exception{
 //BA.debugLineNum = 64;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
 //BA.debugLineNum = 65;BA.debugLine="If UserClosed Then";
if (_userclosed) { 
 //BA.debugLineNum = 66;BA.debugLine="AStreams.Close";
mostCurrent._astreams.Close();
 };
 //BA.debugLineNum = 68;BA.debugLine="End Sub";
return "";
}
public static String  _activity_resume() throws Exception{
 //BA.debugLineNum = 55;BA.debugLine="Sub Activity_Resume";
 //BA.debugLineNum = 56;BA.debugLine="If Serial1.IsEnabled = False Then";
if (mostCurrent._serial1.IsEnabled()==anywheresoftware.b4a.keywords.Common.False) { 
 //BA.debugLineNum = 57;BA.debugLine="Msgbox(\"Por favor enable Bluetooth.\", \"\")";
anywheresoftware.b4a.keywords.Common.Msgbox("Por favor enable Bluetooth.","",mostCurrent.activityBA);
 //BA.debugLineNum = 58;BA.debugLine="salir_Click";
_salir_click();
 }else {
 //BA.debugLineNum = 60;BA.debugLine="Serial1.Listen";
mostCurrent._serial1.Listen(processBA);
 };
 //BA.debugLineNum = 62;BA.debugLine="End Sub";
return "";
}
public static String  _activity_touch(int _action,float _x,float _y) throws Exception{
 //BA.debugLineNum = 78;BA.debugLine="Sub Activity_Touch (Action As Int, x As Float, Y As Float)";
 //BA.debugLineNum = 80;BA.debugLine="xx = (x)";
_xx = (int) ((_x));
 //BA.debugLineNum = 81;BA.debugLine="yy = (Y)";
_yy = (int) ((_y));
 //BA.debugLineNum = 82;BA.debugLine="If Action=1 Then";
if (_action==1) { 
 //BA.debugLineNum = 83;BA.debugLine="parar";
_parar();
 }else {
 //BA.debugLineNum = 85;BA.debugLine="calculo";
_calculo();
 };
 //BA.debugLineNum = 89;BA.debugLine="End Sub";
return "";
}
public static String  _astreams_error() throws Exception{
 //BA.debugLineNum = 74;BA.debugLine="Sub AStreams_Error";
 //BA.debugLineNum = 75;BA.debugLine="ToastMessageShow(LastException.Message, True)";
anywheresoftware.b4a.keywords.Common.ToastMessageShow(anywheresoftware.b4a.keywords.Common.LastException(mostCurrent.activityBA).getMessage(),anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 76;BA.debugLine="End Sub";
return "";
}
public static String  _astreams_newdata(byte[] _buffer) throws Exception{
 //BA.debugLineNum = 70;BA.debugLine="Sub AStreams_NewData (buffer() As Byte)";
 //BA.debugLineNum = 71;BA.debugLine="TextSend.Text =  \"->\" & BytesToString(buffer, 0, buffer.Length, \"ASCII\")";
mostCurrent._textsend.setText((Object)("->"+anywheresoftware.b4a.keywords.Common.BytesToString(_buffer,(int) (0),_buffer.length,"ASCII")));
 //BA.debugLineNum = 72;BA.debugLine="End Sub";
return "";
}
public static String  _calculo() throws Exception{
int _m1 = 0;
int _m2 = 0;
int _zz = 0;
int _xxa = 0;
int _yya = 0;
int _v1 = 0;
int _v2 = 0;
int _valor = 0;
String _s = "";
byte[] _buffer = null;
 //BA.debugLineNum = 100;BA.debugLine="Sub  calculo";
 //BA.debugLineNum = 101;BA.debugLine="Dim m1, m2, zz, xxa, yya As Int";
_m1 = 0;
_m2 = 0;
_zz = 0;
_xxa = 0;
_yya = 0;
 //BA.debugLineNum = 102;BA.debugLine="Dim v1, v2, valor As Int";
_v1 = 0;
_v2 = 0;
_valor = 0;
 //BA.debugLineNum = 104;BA.debugLine="Dim s As String";
_s = "";
 //BA.debugLineNum = 105;BA.debugLine="Dim buffer() As Byte";
_buffer = new byte[(int) (0)];
;
 //BA.debugLineNum = 111;BA.debugLine="xx=(xx-160)/40";
_xx = (int) ((_xx-160)/(double)40);
 //BA.debugLineNum = 112;BA.debugLine="yy=(yy-160)/40";
_yy = (int) ((_yy-160)/(double)40);
 //BA.debugLineNum = 114;BA.debugLine="yy=yy*-1";
_yy = (int) (_yy*-1);
 //BA.debugLineNum = 116;BA.debugLine="If xx>3 Then xx=3";
if (_xx>3) { 
_xx = (int) (3);};
 //BA.debugLineNum = 117;BA.debugLine="If yy>3 Then yy=3";
if (_yy>3) { 
_yy = (int) (3);};
 //BA.debugLineNum = 118;BA.debugLine="If xx<-3 Then xx=-3";
if (_xx<-3) { 
_xx = (int) (-3);};
 //BA.debugLineNum = 119;BA.debugLine="If yy<-3 Then yy=-3";
if (_yy<-3) { 
_yy = (int) (-3);};
 //BA.debugLineNum = 121;BA.debugLine="xxa=xx";
_xxa = _xx;
 //BA.debugLineNum = 122;BA.debugLine="yya=yy";
_yya = _yy;
 //BA.debugLineNum = 123;BA.debugLine="If xxa<0 Then xxa=xxa*-1";
if (_xxa<0) { 
_xxa = (int) (_xxa*-1);};
 //BA.debugLineNum = 124;BA.debugLine="If yya<0 Then yya=yya*-1";
if (_yya<0) { 
_yya = (int) (_yya*-1);};
 //BA.debugLineNum = 126;BA.debugLine="If yy > 0 Then";
if (_yy>0) { 
 //BA.debugLineNum = 127;BA.debugLine="m1 = 1";
_m1 = (int) (1);
 //BA.debugLineNum = 128;BA.debugLine="m2 = 1";
_m2 = (int) (1);
 }else {
 //BA.debugLineNum = 130;BA.debugLine="m1 = 0";
_m1 = (int) (0);
 //BA.debugLineNum = 131;BA.debugLine="m2 = 0";
_m2 = (int) (0);
 };
 //BA.debugLineNum = 134;BA.debugLine="If yy = 0 Then";
if (_yy==0) { 
 //BA.debugLineNum = 135;BA.debugLine="If xx > 0 Then";
if (_xx>0) { 
 //BA.debugLineNum = 136;BA.debugLine="m1 = 0";
_m1 = (int) (0);
 //BA.debugLineNum = 137;BA.debugLine="m2 = 1";
_m2 = (int) (1);
 };
 //BA.debugLineNum = 140;BA.debugLine="If xx < 0 Then";
if (_xx<0) { 
 //BA.debugLineNum = 141;BA.debugLine="m1 = 1";
_m1 = (int) (1);
 //BA.debugLineNum = 142;BA.debugLine="m2 = 0";
_m2 = (int) (0);
 };
 //BA.debugLineNum = 145;BA.debugLine="If xx = 0 Then";
if (_xx==0) { 
 //BA.debugLineNum = 146;BA.debugLine="m1 = 2";
_m1 = (int) (2);
 //BA.debugLineNum = 147;BA.debugLine="m2 = 2";
_m2 = (int) (2);
 };
 };
 //BA.debugLineNum = 152;BA.debugLine="If m1 = 2 Then";
if (_m1==2) { 
 }else {
 //BA.debugLineNum = 155;BA.debugLine="If m1 = 1 Then";
if (_m1==1) { 
 //BA.debugLineNum = 156;BA.debugLine="valor = valor + 128";
_valor = (int) (_valor+128);
 }else {
 //BA.debugLineNum = 158;BA.debugLine="valor = valor + 64";
_valor = (int) (_valor+64);
 };
 };
 //BA.debugLineNum = 163;BA.debugLine="If m2 = 2 Then";
if (_m2==2) { 
 }else {
 //BA.debugLineNum = 166;BA.debugLine="If m2 = 1 Then";
if (_m2==1) { 
 //BA.debugLineNum = 167;BA.debugLine="valor = valor + 8";
_valor = (int) (_valor+8);
 }else {
 //BA.debugLineNum = 169;BA.debugLine="valor = valor + 4";
_valor = (int) (_valor+4);
 };
 };
 //BA.debugLineNum = 174;BA.debugLine="zz = (xxa * yya) / 3";
_zz = (int) ((_xxa*_yya)/(double)3);
 //BA.debugLineNum = 176;BA.debugLine="v1 = yya";
_v1 = _yya;
 //BA.debugLineNum = 177;BA.debugLine="v2 = yya";
_v2 = _yya;
 //BA.debugLineNum = 178;BA.debugLine="If xx < 0 Then";
if (_xx<0) { 
 //BA.debugLineNum = 179;BA.debugLine="v1 = (v1 - zz)";
_v1 = (int) ((_v1-_zz));
 };
 //BA.debugLineNum = 182;BA.debugLine="If xx > 0 Then";
if (_xx>0) { 
 //BA.debugLineNum = 183;BA.debugLine="v2 = (v2 - zz)";
_v2 = (int) ((_v2-_zz));
 };
 //BA.debugLineNum = 185;BA.debugLine="If yy = 0 Then";
if (_yy==0) { 
 //BA.debugLineNum = 186;BA.debugLine="v1 = xxa";
_v1 = _xxa;
 //BA.debugLineNum = 187;BA.debugLine="v2 = xxa";
_v2 = _xxa;
 };
 //BA.debugLineNum = 190;BA.debugLine="If v1 < 0 Then v1 = 0";
if (_v1<0) { 
_v1 = (int) (0);};
 //BA.debugLineNum = 191;BA.debugLine="If v2 < 0 Then v2 = 0";
if (_v2<0) { 
_v2 = (int) (0);};
 //BA.debugLineNum = 193;BA.debugLine="If v1 > 3 Then v1 = 3";
if (_v1>3) { 
_v1 = (int) (3);};
 //BA.debugLineNum = 194;BA.debugLine="If v2 > 3 Then v2 = 3";
if (_v2>3) { 
_v2 = (int) (3);};
 //BA.debugLineNum = 196;BA.debugLine="valor = valor + v2";
_valor = (int) (_valor+_v2);
 //BA.debugLineNum = 197;BA.debugLine="valor = valor + v1 * 16";
_valor = (int) (_valor+_v1*16);
 //BA.debugLineNum = 199;BA.debugLine="If valorViejo <> valor Then";
if (_valorviejo!=_valor) { 
 //BA.debugLineNum = 200;BA.debugLine="valorViejo = valor";
_valorviejo = _valor;
 //BA.debugLineNum = 201;BA.debugLine="If connected Then";
if (_connected) { 
 //BA.debugLineNum = 202;BA.debugLine="s =  \"valor\" & valor & Chr(10)";
_s = "valor"+BA.NumberToString(_valor)+BA.ObjectToString(anywheresoftware.b4a.keywords.Common.Chr((int) (10)));
 //BA.debugLineNum = 203;BA.debugLine="buffer = s.GetBytes(\"UTF8\")";
_buffer = _s.getBytes("UTF8");
 //BA.debugLineNum = 204;BA.debugLine="AStreams.Write(buffer)";
mostCurrent._astreams.Write(_buffer);
 //BA.debugLineNum = 208;BA.debugLine="TextSend.Text = \"valor\" & valor";
mostCurrent._textsend.setText((Object)("valor"+BA.NumberToString(_valor)));
 };
 };
 //BA.debugLineNum = 213;BA.debugLine="End Sub";
return "";
}

public static void initializeProcessGlobals() {
    
    if (main.processGlobalsRun == false) {
	    main.processGlobalsRun = true;
		try {
		        main._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}public static String  _globals() throws Exception{
 //BA.debugLineNum = 21;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 22;BA.debugLine="Dim Serial1 As  Serial";
mostCurrent._serial1 = new anywheresoftware.b4a.objects.Serial();
 //BA.debugLineNum = 23;BA.debugLine="Dim AStreams As AsyncStreams";
mostCurrent._astreams = new anywheresoftware.b4a.randomaccessfile.AsyncStreams();
 //BA.debugLineNum = 24;BA.debugLine="Dim connected As Boolean";
_connected = false;
 //BA.debugLineNum = 26;BA.debugLine="Dim TextLog As EditText";
mostCurrent._textlog = new anywheresoftware.b4a.objects.EditTextWrapper();
 //BA.debugLineNum = 27;BA.debugLine="Dim TextSend As EditText";
mostCurrent._textsend = new anywheresoftware.b4a.objects.EditTextWrapper();
 //BA.debugLineNum = 29;BA.debugLine="Dim xx As Int";
_xx = 0;
 //BA.debugLineNum = 30;BA.debugLine="Dim yy As Int";
_yy = 0;
 //BA.debugLineNum = 31;BA.debugLine="Dim valorViejo As Int";
_valorviejo = 0;
 //BA.debugLineNum = 34;BA.debugLine="End Sub";
return "";
}
public static String  _mnuacerca_click() throws Exception{
 //BA.debugLineNum = 45;BA.debugLine="Sub mnuAcerca_Click";
 //BA.debugLineNum = 46;BA.debugLine="Msgbox(\"xsetaseta@gmail.com\", \"\")";
anywheresoftware.b4a.keywords.Common.Msgbox("xsetaseta@gmail.com","",mostCurrent.activityBA);
 //BA.debugLineNum = 47;BA.debugLine="TextLog.Text = TextLog.Text & \" xsetaseta@gmail.com \"";
mostCurrent._textlog.setText((Object)(mostCurrent._textlog.getText()+" xsetaseta@gmail.com "));
 //BA.debugLineNum = 48;BA.debugLine="End Sub";
return "";
}
public static String  _mnuayuda_click() throws Exception{
 //BA.debugLineNum = 50;BA.debugLine="Sub mnuAyuda_Click";
 //BA.debugLineNum = 51;BA.debugLine="Msgbox(\"autoFelipe3\", \"\")";
anywheresoftware.b4a.keywords.Common.Msgbox("autoFelipe3","",mostCurrent.activityBA);
 //BA.debugLineNum = 52;BA.debugLine="TextLog.Text = TextLog.Text & \" autoFelipe3 \"";
mostCurrent._textlog.setText((Object)(mostCurrent._textlog.getText()+" autoFelipe3 "));
 //BA.debugLineNum = 53;BA.debugLine="End Sub";
return "";
}
public static String  _open_click() throws Exception{
anywheresoftware.b4a.objects.collections.Map _paireddevices = null;
anywheresoftware.b4a.objects.collections.List _l = null;
int _i = 0;
int _res = 0;
 //BA.debugLineNum = 215;BA.debugLine="Sub open_Click";
 //BA.debugLineNum = 216;BA.debugLine="Dim PairedDevices As Map";
_paireddevices = new anywheresoftware.b4a.objects.collections.Map();
 //BA.debugLineNum = 217;BA.debugLine="PairedDevices = Serial1.GetPairedDevices";
_paireddevices = mostCurrent._serial1.GetPairedDevices();
 //BA.debugLineNum = 218;BA.debugLine="Dim l As List";
_l = new anywheresoftware.b4a.objects.collections.List();
 //BA.debugLineNum = 219;BA.debugLine="l.Initialize";
_l.Initialize();
 //BA.debugLineNum = 220;BA.debugLine="For i = 0 To PairedDevices.Size - 1";
{
final int step151 = 1;
final int limit151 = (int) (_paireddevices.getSize()-1);
for (_i = (int) (0); (step151 > 0 && _i <= limit151) || (step151 < 0 && _i >= limit151); _i = ((int)(0 + _i + step151))) {
 //BA.debugLineNum = 221;BA.debugLine="l.Add(PairedDevices.GetKeyAt(i)) 'add the friendly name to the list";
_l.Add(_paireddevices.GetKeyAt(_i));
 }
};
 //BA.debugLineNum = 223;BA.debugLine="Dim res As Int";
_res = 0;
 //BA.debugLineNum = 224;BA.debugLine="res = InputList(l, \"Selecciona dispositivo\", -1) 'show list with paired devices";
_res = anywheresoftware.b4a.keywords.Common.InputList(_l,"Selecciona dispositivo",(int) (-1),mostCurrent.activityBA);
 //BA.debugLineNum = 226;BA.debugLine="If res <> DialogResponse.CANCEL Then";
if (_res!=anywheresoftware.b4a.keywords.Common.DialogResponse.CANCEL) { 
 //BA.debugLineNum = 227;BA.debugLine="Serial1.Connect(PairedDevices.Get(l.Get(res))) 'convert the name to mac address";
mostCurrent._serial1.Connect(processBA,BA.ObjectToString(_paireddevices.Get(_l.Get(_res))));
 //BA.debugLineNum = 228;BA.debugLine="TextLog.Text =  \"Conectando a: \" & l.Get(res)";
mostCurrent._textlog.setText((Object)("Conectando a: "+BA.ObjectToString(_l.Get(_res))));
 };
 //BA.debugLineNum = 230;BA.debugLine="End Sub";
return "";
}
public static String  _parar() throws Exception{
String _s = "";
byte[] _buffer = null;
 //BA.debugLineNum = 245;BA.debugLine="Sub parar";
 //BA.debugLineNum = 246;BA.debugLine="Dim s As String";
_s = "";
 //BA.debugLineNum = 247;BA.debugLine="Dim buffer() As Byte";
_buffer = new byte[(int) (0)];
;
 //BA.debugLineNum = 249;BA.debugLine="s =  \"valor\" & 0 & Chr(10)";
_s = "valor"+BA.NumberToString(0)+BA.ObjectToString(anywheresoftware.b4a.keywords.Common.Chr((int) (10)));
 //BA.debugLineNum = 250;BA.debugLine="buffer = s.GetBytes(\"UTF8\")";
_buffer = _s.getBytes("UTF8");
 //BA.debugLineNum = 251;BA.debugLine="AStreams.Write(buffer)";
mostCurrent._astreams.Write(_buffer);
 //BA.debugLineNum = 252;BA.debugLine="valorViejo=0";
_valorviejo = (int) (0);
 //BA.debugLineNum = 253;BA.debugLine="TextSend.Text =\" valor0\"";
mostCurrent._textsend.setText((Object)(" valor0"));
 //BA.debugLineNum = 255;BA.debugLine="End Sub";
return "";
}
public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 15;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 19;BA.debugLine="End Sub";
return "";
}
public static String  _salir_click() throws Exception{
 //BA.debugLineNum = 90;BA.debugLine="Sub salir_Click";
 //BA.debugLineNum = 92;BA.debugLine="parar";
_parar();
 //BA.debugLineNum = 93;BA.debugLine="Serial1.Disconnect";
mostCurrent._serial1.Disconnect();
 //BA.debugLineNum = 94;BA.debugLine="TextLog.Text =  \" Desconectado  \"";
mostCurrent._textlog.setText((Object)(" Desconectado  "));
 //BA.debugLineNum = 95;BA.debugLine="connected = False";
_connected = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 96;BA.debugLine="Msgbox(\"Programa terminado\", \"\")";
anywheresoftware.b4a.keywords.Common.Msgbox("Programa terminado","",mostCurrent.activityBA);
 //BA.debugLineNum = 97;BA.debugLine="ExitApplication";
anywheresoftware.b4a.keywords.Common.ExitApplication();
 //BA.debugLineNum = 98;BA.debugLine="End Sub";
return "";
}
public static String  _serial1_connected(boolean _success) throws Exception{
 //BA.debugLineNum = 232;BA.debugLine="Sub Serial1_Connected (Success As Boolean)";
 //BA.debugLineNum = 234;BA.debugLine="If Success Then";
if (_success) { 
 //BA.debugLineNum = 235;BA.debugLine="AStreams.Initialize (Serial1.InputStream ,Serial1.OutputStream ,\"AStreams\")";
mostCurrent._astreams.Initialize(processBA,mostCurrent._serial1.getInputStream(),mostCurrent._serial1.getOutputStream(),"AStreams");
 //BA.debugLineNum = 236;BA.debugLine="TextLog.Text = TextLog.Text & \"  Conectado  \"";
mostCurrent._textlog.setText((Object)(mostCurrent._textlog.getText()+"  Conectado  "));
 //BA.debugLineNum = 237;BA.debugLine="connected = True";
_connected = anywheresoftware.b4a.keywords.Common.True;
 }else {
 //BA.debugLineNum = 239;BA.debugLine="connected = False";
_connected = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 240;BA.debugLine="Msgbox(LastException.Message, \"Error de conexion.\")";
anywheresoftware.b4a.keywords.Common.Msgbox(anywheresoftware.b4a.keywords.Common.LastException(mostCurrent.activityBA).getMessage(),"Error de conexion.",mostCurrent.activityBA);
 };
 //BA.debugLineNum = 242;BA.debugLine="End Sub";
return "";
}
}
